m_HMM_main <-
function(sample_reads_input, reference_reads_input, loci_input, kmeans1=TRUE, C.const=40, change_point_refine=TRUE)
{
  #First group the sites into windows
  
  combined.file<-"combined_data.RData"
  
  windows_group<-window_groupping_func(loci_input, sample_reads_input, reference_reads_input, combined.file, kmeans1=kmeans1, C.const=C.const, n_chunk_1=60)
  
  cut_off_tot_ind<-windows_group$cut_off_tot_ind
  sample_vec_combine<-windows_group$sample_vec_combine #tapply(sample_reads_input,cut_off_tot_ind,sum)
  control_vec_combine<-windows_group$control_vec_combine #tapply(reference_reads_input,cut_off_tot_ind,sum)
  posi_vec_combine<-windows_group$posi_vec_combine  #round(tapply(loci_input,cut_off_tot_ind,median))
  
  #   save( cut_off_tot_ind, sample_vec_combine, control_vec_combine, posi_vec_combine, file="combined_data.RData")
  
  #  load("combined_data1_10000.RData")
  #  file_output<-"R_m_HMM_output_10000.txt"
  
  # dyn.load("eln_program_R_call.dll")
  
  K_vec<-c(0.5, 1, 2, 0)
  pi_vec<-c(0, 1, 0, 0)
  lambda_vec<-c(10^5, 10^10, 10^5, 10^5)
  
  p_mat <- matrix(rep(0.001,16),nrow=4)
  diag(p_mat) <- 0
  
  alphain=100;
  betain=2;    
  rin=0.5;
  c0in=1;
  
  sample_vec_double<-sample_vec_combine
  control_vec_double<-control_vec_combine
  posi_vec<- posi_vec_combine
  
  
  T<-length(sample_vec_double)
  states_guess<-rep(1, T)
  
 # cat("lambda vector is: \n", file=file_output)
 # cat(lambda_vec, sep="\t", file=file_output, append = TRUE)
 # cat("\n", file=file_output, append = TRUE)
  
  ii_out<-1
  alpha_beta_diff_out<-1
  alpha_out<-alphain
  beta_out<-betain
  r_out<-rin
  
  file_1<-"iterations.txt"
  
  m_HMM_Cres<-.C("CNV_HMM_func_1", M=as.integer(4), T=as.integer(T), alpha=as.double(alphain), beta=as.double(betain), sample_vec=as.integer(sample_vec_double), control_vec=as.integer(control_vec_double), 
                 sample_vec_double=as.double(sample_vec_double), control_vec_double=as.double(control_vec_double), posi_vec=as.double(posi_vec), K_vec=as.double(K_vec), c0=as.double(c0in), states_guess=as.integer(states_guess), 
                 pi_vec=as.double(pi_vec), r=as.double(rin), p_mat=as.matrix(p_mat), lambda_vec=as.double(lambda_vec),
                 ii_out=as.integer(ii_out), alpha_beta_diff_out=as.double(alpha_beta_diff_out), alpha_out=as.double(alpha_out), beta_out=as.double(beta_out), r_out=as.double(r_out), filename=file_1)
  
  #   sample_reads_combined<-m_HMM_Cres$sample_vec
  #   reference_reads_combined<-m_HMM_Cres$control_vec
  #   locations<-m_HMM_Cres$posi_vec  
  states_guess_combine<-m_HMM_Cres$states_guess
  
  save(sample_vec_combine, control_vec_combine, posi_vec_combine, states_guess_combine, file="combined_result.RData")
  
  CNV_windows_combine<-as.numeric(names(posi_vec_combine[which(states_guess_combine==0 | states_guess_combine==2 | states_guess_combine==3)])) # the position indicator where the result has changed, compared with its last location
  
  CNV_windows_change<-CNV_windows_combine[2:length(CNV_windows_combine)] - CNV_windows_combine[1:(length(CNV_windows_combine)-1)]
  
  which_CNV_windows_change_right<-c(CNV_windows_combine[which(CNV_windows_change>1)], max(CNV_windows_combine))
  which_CNV_windows_change_left<-c(min(CNV_windows_combine), CNV_windows_combine[which(CNV_windows_change>1)+1])
  
  left_before_refine_location_vec<-rep(0, length(which_CNV_windows_change_left))
  right_before_refine_location_vec<-rep(0, length(which_CNV_windows_change_left))
  state_result_vec<-rep(0, length(which_CNV_windows_change_left))
  state_result_vec_statement<-rep(0, length(which_CNV_windows_change_left))
  CNVlength_vec<-rep(0, length(which_CNV_windows_change_left))
  ratio_vec<-rep(0, length(which_CNV_windows_change_left))
  
  roundUp <- function(x,to=100)
  {
    to*(x%/%to + as.logical(x%%to))
  }
  
  for (i in 1:length(which_CNV_windows_change_left)) 
  {
    left_before_refine_location_vec[i] <- posi_vec_combine[which(names(posi_vec_combine)==which_CNV_windows_change_left[i])]
    right_before_refine_location_vec[i] <- posi_vec_combine[which(names(posi_vec_combine)==which_CNV_windows_change_right[i])]
    state_result_vec[i]<-states_guess_combine[median(which(names(posi_vec_combine)==which_CNV_windows_change_left[i]):which(names(posi_vec_combine)==which_CNV_windows_change_left[i]))]
    if (state_result_vec[i]==0)
      state_result_vec_statement[i]<-"deletion"
    if (state_result_vec[i]==2)
      state_result_vec_statement[i]<-"duplication"
    if (state_result_vec[i]==3)
      state_result_vec_statement[i]<-"absent"
    CNVlength_vec[i]<-roundUp(right_before_refine_location_vec[i] - left_before_refine_location_vec[i])
    l<-which(names(posi_vec_combine)==which_CNV_windows_change_left[i])
    r<-which(names(posi_vec_combine)==which_CNV_windows_change_right[i])
    ratio_vec[i]<-sum(sample_vec_combine[l:r])/(sum(control_vec_combine[l:r])*c0in)
  }
  
  CNV_detection_before_refine<-data.frame(left_before_refine_location_vec, right_before_refine_location_vec, state_result_vec_statement, CNVlength_vec, ratio_vec)
  colnames(CNV_detection_before_refine)<-c("left", "right", "state", "length", "ratio")
  save(CNV_detection_before_refine, file="CNV_detection_before_refine.RData")
  
  if (change_point_refine == FALSE)
  {return(CNV_detection_before_refine)}
  
  if (change_point_refine == TRUE)
  {
    left_refine_location_vec<-rep(0, length(which_CNV_windows_change_left))
    right_refine_location_vec<-rep(0, length(which_CNV_windows_change_left))
    
    for (i in 1:length(which_CNV_windows_change_left)) 
    {

      left_refine_ind<-which(cut_off_tot_ind == which_CNV_windows_change_left[i]-1 | cut_off_tot_ind == which_CNV_windows_change_left[i]) 
      right_refine_ind<-which(cut_off_tot_ind == which_CNV_windows_change_right[i] | cut_off_tot_ind == which_CNV_windows_change_right[i]+1) 
      
      
      if (left_before_refine_location_vec[i] == right_before_refine_location_vec[i])
      {
        
        left_refine_location_vec[i]<-min(loci_input[left_refine_ind])
        right_refine_location_vec[i]<-max(loci_input[left_refine_ind])
      }
      
      if (left_before_refine_location_vec[i] != right_before_refine_location_vec[i])
      {
        #left window edge refine
        #   left_refine_ind<-which(cut_off_tot_ind == which_CNV_windows_change_left[i]-1 | cut_off_tot_ind == which_CNV_windows_change_left[i]) 
        
        chi_stat_refine_left<-NULL
        for (j in 1:length(left_refine_ind))    
        {
          sample_l<-sum(sample_reads_input[min(left_refine_ind) : (j+max(left_refine_ind)-1)])
          control_l<-sum(reference_reads_input[min(left_refine_ind) : (j+max(left_refine_ind)-1)])
          sample_r<-sum(sample_reads_input[(j+min(left_refine_ind)) : max(left_refine_ind)])
          control_r<-sum(reference_reads_input[(j+min(left_refine_ind)) : max(left_refine_ind)])
          
          sample_l<-sample_l*1.0
          control_l<-control_l*1.0
          sample_r<-sample_r*1.0
          control_r<-control_r*1.0
          
          x<-matrix(c(sample_l, control_l, sample_r, control_r), ncol=2)
          chi_stat_refine_left<-c(chi_stat_refine_left,chi.sq.test.stat(x))  
        }
        
        left_refine_location<-loci_input[left_refine_ind[which.max(chi_stat_refine_left)]]
        left_refine_location_vec[i]<-left_refine_location
        
        #right window edge refine
        #    right_refine_ind<-which(cut_off_tot_ind == which_CNV_windows_change_right[i] | cut_off_tot_ind == which_CNV_windows_change_right[i]+1) 
        
        chi_stat_refine_right<-NULL
        for (j in 1:length(right_refine_ind))    
        {
          sample_l<-sum(sample_reads_input[min(right_refine_ind) : (j+max(right_refine_ind)-1)])
          control_l<-sum(reference_reads_input[min(right_refine_ind) : (j+max(right_refine_ind)-1)])
          sample_r<-sum(sample_reads_input[(j+min(right_refine_ind)) : max(right_refine_ind)])
          control_r<-sum(reference_reads_input[(j+min(right_refine_ind)) : max(right_refine_ind)])
          
          sample_l<-sample_l*1.0
          control_l<-control_l*1.0
          sample_r<-sample_r*1.0
          control_r<-control_r*1.0
          
          x<-matrix(c(sample_l, control_l, sample_r, control_r), ncol=2)
          chi_stat_refine_right<-c(chi_stat_refine_right,chi.sq.test.stat(x))  
        }
        
        right_refine_location<-loci_input[right_refine_ind[which.max(chi_stat_refine_right)]]
        right_refine_location_vec[i]<-right_refine_location
        
      }
     }
      CNV_detection_refine<-data.frame(left_refine_location_vec, right_refine_location_vec, CNV_detection_before_refine[,3], right_refine_location_vec-left_refine_location_vec, CNV_detection_before_refine[,5])
      colnames(CNV_detection_refine)<-c("left", "right", "state", "length", "ratio")
      save(CNV_detection_refine, file="CNV_detection_refine.RData")
      return(CNV_detection_refine)
    }
}
