window_groupping_func <-
function(posi_vec, sample_vec, control_vec, combined.file, kmeans1=FALSE, C.const=40, n_chunk_1=60)
{
  LL<-length(posi_vec)
  
  if (kmeans1 == FALSE)
  {
    n_chunk<-round(length(sample_vec)/200)
    which_max<-sort(round(c(1, runif(n_chunk-1, 1, LL), LL)))
    diff<-which_max[2:length(which_max)]- which_max[1:(length(which_max)-1)]
    
    cut_off_tot_ind<-c(1,rep(seq(1:(length(which_max)-1)), diff))
  }
  
  if (kmeans1 == TRUE)
  {
   
    
    diff<-posi_vec[2:LL]-posi_vec[1:(LL-1)]
    diff_large<-sort(unique(diff),decreasing=TRUE)[1:(n_chunk_1)]  # n_chunk_1 largest position differences
    which_max<-NULL
    for (i in 1:(n_chunk_1))
    {
      which_max<-c(which_max,which(diff==diff_large[i]))
    }
  
   which_max<-sort(unique(which_max))
    which_max<-c(0, which_max, LL)
  #  which_max_space<-which_max[2:length(which_max)]-which_max[1:(length(which_max)-1)]
    
    parts.N<-length(which_max)-1
    parts <- rep(list(0), parts.N)
    for (i in 1:parts.N)
    {
      parts[[i]]<-posi_vec[(which_max[i]+1):(which_max[i+1])]
      
    }
    
    cut_off_part = rep(list(1), parts.N)
    for (i in 1:parts.N)
    {
      if (length(parts[[i]])>C.const)
      {
        KK<-round(length(parts[[i]])/C.const+2)
        #cut_off_part[[i]]<-kmeans(parts[[i]],sort(unique(round(runif(KK, min(parts[[i]]), max(parts[[i]]))))), algorithm = "Hartigan-Wong")$cluster
        cut_off_part[[i]]<-kmeans(parts[[i]],KK, algorithm = "Hartigan-Wong")$cluster
      
      }
    }
    
    cut_off<-NULL
    for (i in 1:parts.N)
    {
      part_result<-cut_off_part[[i]]
      part_diff<-part_result[2:(length(part_result))]-part_result[1:(length(part_result)-1)]
      cut_off<-c(cut_off, which_max[i], which_max[i]+which(part_diff!=0))
    }
    
    cut_off<-unique(c(cut_off+1,LL))
    cut_off_posi<-rep(0,length(cut_off))
    for (i in 1:length(cut_off))
    {
      cut_off_posi[i]<-posi_vec[cut_off[i]]
    } #physical positions for windows' cut-offs
    
    cut_off_tot_ind<-rep(1,LL)
    k=2
    for (i in 2:LL)
    {
      if (posi_vec[i]!=cut_off_posi[k])
      {
        cut_off_tot_ind[i]<-cut_off_tot_ind[i-1]
      }
      
      if (posi_vec[i]==cut_off_posi[k])
      {
        cut_off_tot_ind[i]<-cut_off_tot_ind[i-1]+1
        if (k<length(cut_off_posi))
        {
          k <- k+1
        }    
      }  
    }
  }
  
  sample_vec_combine<-tapply(sample_vec,cut_off_tot_ind,sum)
  control_vec_combine<-tapply(control_vec,cut_off_tot_ind,sum)
  sum_vec_combine<-sample_vec_combine + control_vec_combine
  posi_vec_combine<-round(tapply(posi_vec,cut_off_tot_ind,median))
  
  save(cut_off_tot_ind, sample_vec, control_vec, posi_vec, sample_vec_combine, control_vec_combine, posi_vec_combine, file=combined.file)
  
  return(list(cut_off_tot_ind=cut_off_tot_ind, sample_vec=sample_vec, control_vec=control_vec, posi_vec=posi_vec, sample_vec_combine=sample_vec_combine, control_vec_combine=control_vec_combine, posi_vec_combine=posi_vec_combine))
}
