\name{m_HMM_main}
\alias{m_HMM_main}
\title{
m_HMM_main
}
\description{
The main function to use m-HMM.
}
\usage{
m_HMM_main(sample_reads_input, reference_reads_input, 
loci_input, kmeans1 = TRUE, 
C.const = 40, change_point_refine = TRUE)
}
\arguments{
  \item{sample_reads_input}{
A vector of sample read counts, with length the same as reference_reads_input and 
loci_input. 
}
  \item{reference_reads_input}{
A vector of reference read counts, with length the same as sample_reads_input and 
loci_input. 
}
  \item{loci_input}{
A vector of physical locations of the reads, with length the same as sample_reads_input
and reference_reads_input.
}
  \item{kmeans1}{
TRUE or FALSE. If kmeans1=TRUE, then the sites are grouped into windows using k-means
method. 
}
  \item{C.const}{
A tuning constant used for site grouping. 
}
  \item{change_point_refine}{
TRUE or FALSE. Whether the change points will be refined after the initial m-HMM.
}
}
\value{
A data frame of the resulting CNV detection. 
}
\references{
Heng Wang, Dan Nettleton and Kai Ying (2014). Copy Number Variation Detection 
Using Next Generation Sequencing Read Counts, BMC Bioinformatics 2014, 15:109.
}
\author{
Heng Wang
}
\examples{
data(control_vec)
data(sample_vec)
data(posi_vec)

reference_reads_input<-control_vec
sample_reads_input<-sample_vec
loci_input<-posi_vec
kmeans1<-TRUE
C.const<-100
change_point_refine<-TRUE

#CNV_detection_result<-m_HMM_main(sample_reads_input, reference_reads_input, 
#loci_input, kmeans1=kmeans1, C.const=C.const, change_point_refine=change_point_refine)

}

